#include <windows.h>
#include <tchar.h>
#include "resource.h"
#include <commdlg.h>
#include <tchar.h>            // for _tcsstr (strstr for Unicode & non-Unicode)

#define MAX_STRING_LEN   256
static HWND  hDlgModeless;
static TCHAR szFindText [MAX_STRING_LEN] ;
static TCHAR szReplText [MAX_STRING_LEN] ;
static CHAR  szReplWhat[80];
bool buttondown=false;
HWND PopFindFindDlg (HWND);
HWND PopFindReplaceDlg (HWND);
//BOOL PopFindFindText (HWND, int *, LPFINDREPLACE);
BOOL PopFindFindText (HWND hwndEdit, int * piSearchOffset, LPFINDREPLACE);
BOOL PopFindNextText (HWND, int *);
BOOL PopFindReplaceText (HWND, int *, LPFINDREPLACE);
BOOL PopFindValidFind (void);
//create text be searched
const TCHAR worddata[] ="It was the best of times, it was the worst of times,"\
" it was the age of wisdom, it was the age of foolishness, it was the epoch of belief"\
", it was the epoch of incredulity, it was the season of Light, "\
"it was the season of Darkness, it was the spring of hope, it was the winter of despair, "\
"we had everything before us, we had nothing before us, we were all going direct to Heaven, "\
"we were all going direct the other way  in short, the period was so far like the present period, "\
"that some of its noisiest authorities insisted on its being received, for good or for evil, "\
"in the superlative degree of comparison only.";
HINSTANCE hInst = NULL;
const UINT uFindReplaceMsg = RegisterWindowMessage(FINDMSGSTRING);//Registering FINDMSGSTRING
HWND hdlg = NULL;     // handle to Find dialog box
int findFrom = 0;
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;
//search file 
int SearchFile(const TCHAR* find, BOOL down, BOOL ignoreCase)
{
if(0 < _tcslen(find))
{
const TCHAR* start = &worddata[findFrom];
const TCHAR* pos   = _tcsstr(start, find);
if(NULL != pos)
{
int foundAt = (pos - worddata);
findFrom = foundAt + _tcslen(find);
return foundAt;
}
}
findFrom = 0;
return -1;
}
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
PSTR szCmdLine, int iCmdShow)
{
static TCHAR szAppName[] = TEXT ("TextFind Demo") ; 
HWND         hwnd ;
MSG          msg ;
WNDCLASS     wndclass = {0}; 
hInst = hInstance;
wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
wndclass.lpfnWndProc   = WndProc ;
wndclass.cbClsExtra    = 0 ;
wndclass.cbWndExtra    = 0 ;
wndclass.hInstance     = hInstance ;
wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
wndclass.hbrBackground = NULL; 
wndclass.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU1); 
wndclass.lpszClassName = szAppName ;
if (!RegisterClass (&wndclass))
{
MessageBox (NULL, TEXT ("Program requires Windows NT!"), 
szAppName, MB_ICONERROR) ;
return 0 ;
}
hwnd = CreateWindow (szAppName, TEXT ("Find Text in Edit Control Demo"),WS_OVERLAPPEDWINDOW,CW_USEDEFAULT, CW_USEDEFAULT,CW_USEDEFAULT, CW_USEDEFAULT,NULL, NULL, hInstance, NULL) ;
ShowWindow (hwnd, iCmdShow) ;
UpdateWindow (hwnd) ;
while (GetMessage (&msg, NULL, 0, 0))
{
TranslateMessage (&msg) ;
DispatchMessage (&msg) ;
}
return msg.wParam ;
}
LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static BOOL      bNeedSave = FALSE ;
     static HINSTANCE hInst ;
     static HWND      hwndEdit ;
     static int       iOffset ;
     static TCHAR     szFileName[MAX_PATH], szTitleName[MAX_PATH] ;
     static UINT      messageFindReplace ;
     int              iSelBeg, iSelEnd, iEnable ;
     //LPFINDREPLACE    pfr ;
	 static FINDREPLACE pfr;
//static HWND hEdit = NULL;
static HBRUSH hbrWhite = (HBRUSH)GetStockObject(WHITE_BRUSH);
switch (message)
{
case WM_CREATE:
hwndEdit  = CreateWindow (TEXT("EDIT"), worddata,WS_CHILD | WS_VISIBLE | ES_MULTILINE|ES_READONLY  | ES_NOHIDESEL,0, 0, 0, 0,  hwnd, (HMENU)100, hInst, NULL) ;
//return 0;
break;
case WM_SIZE:
if(hwndEdit!=NULL)
MoveWindow(hwndEdit, 0, 0, LOWORD(lParam), HIWORD(lParam), FALSE);
return 0;

case WM_COMMAND:
switch(LOWORD(wParam))
{
	case WM_LBUTTONDOWN:
	{

buttondown=true;
	}
	break;
case IDM_FIND: 
	{
		      SendMessage (hwndEdit, EM_GETSEL, 0, (LPARAM) &iOffset) ;
               hDlgModeless = PopFindFindDlg(hwnd) ;
               //return 0 
     // SendMessage (hwndEdit, EM_GETSEL, 0, (LPARAM) &iOffset) ;
	  //int *a=&iOffset;
            //   hDlgModeless = PopFindReplaceDlg (hwnd) ;
 
//static CHAR szFindWhat[80];  // buffer receiving string
//	SendMessage (hwndEdit, EM_GETSEL, 0, (LPARAM) &iOffset) ;
     //          hDlgModeless = PopFindReplaceDlg (hwnd) ;
      //         return 0 ;

// Initialize FINDREPLACE
	/*
ZeroMemory(&pfr, sizeof(pfr));

  pfr.lStructSize = sizeof (FINDREPLACE) ;
     pfr.hwndOwner = hwnd;
     pfr.hInstance = NULL;
     pfr.Flags = FR_HIDEUPDOWN | FR_HIDEMATCHCASE | FR_HIDEWHOLEWORD ;
//     pfr.lpstrFindWhat = szFindWhat;
     pfr.lpstrReplaceWith = szReplWhat ;
     pfr.wFindWhatLen = 80;
     pfr.wReplaceWithLen = 80;
     pfr.lCustData = 0;
     pfr.lpfnHook = NULL;
     pfr.lpTemplateName = NULL;
	 SendMessage (hwndEdit, EM_GETSEL, 0, (LPARAM) &iOffset) ;
	 */
//               hDlgModeless = PopFindReplaceDlg (hwnd) ;
	}
               return 0 ;
//fr.lStructSize = sizeof(fr);
//fr.hwndOwner = hwnd;
//fr.lpstrFindWhat = szFindWhat;
//fr.wFindWhatLen = 80;
//fr.Flags = 0;
//hdlg = ReplaceText(&fr);
//return 0; 
case IDM_REPLACE:
	{
		//iOffset=0;
       SendMessage (hwndEdit, EM_GETSEL, 0, (LPARAM) &iOffset) ;
               hDlgModeless = PopFindReplaceDlg(hwnd) ;
               return 0 ;
	}
case IDM_EXIT:
DestroyWindow(hwnd);
return 0;
}
break;
case WM_CTLCOLORSTATIC:
return (LRESULT)hbrWhite;
case WM_DESTROY :
PostQuitMessage (0) ;
return 0 ;
default:
LPFINDREPLACE lpfr;
//respond to FINDMSGSTRING message
if (message == uFindReplaceMsg)
{

lpfr = (LPFINDREPLACE)lParam;
if (lpfr->Flags & FR_DIALOGTERM)
          hDlgModeless = NULL ;
               
if (lpfr->Flags & FR_FINDNEXT)
{
if (!PopFindFindText (hwndEdit, &iOffset, lpfr))
MessageBox( NULL, TEXT("Text not found!"), TEXT("Text not found!"), MB_OK );
}
                      //   OkMessage (hwnd, TEXT ("Text not found!"), 
                        //                  TEXT ("\0")) ;
                    
if (lpfr->Flags & FR_REPLACE || lpfr->Flags & FR_REPLACEALL)
{
if (!PopFindReplaceText (hwndEdit, &iOffset, lpfr))
	MessageBox( NULL, TEXT("Text not found!"), TEXT("Text not found!"), MB_OK );
}
                      //   OkMessage (hwnd, TEXT ("Text not found!"), 
                       //                   TEXT ("\0")) ;
if (lpfr->Flags & FR_REPLACEALL)
{
while (PopFindReplaceText (hwndEdit, &iOffset, lpfr)) ;
return 0;
	  //int *a=&iOffset;
//	  a=0;
// SendMessage (hwndEdit, EM_SCROLLCARET, 0, 0) ;
}
//return 0 ;
} 
//else 
return DefWindowProc (hwnd, message, wParam, lParam) ;
}
return 0;
}


HWND PopFindFindDlg (HWND hwnd)
{
     static FINDREPLACE fr ;       // must be static for modeless dialog!!!
     
     fr.lStructSize      = sizeof (FINDREPLACE) ;
     fr.hwndOwner        = hwnd ;
     fr.hInstance        = NULL ;
     fr.Flags            = FR_HIDEUPDOWN | FR_HIDEMATCHCASE | FR_HIDEWHOLEWORD ;
     fr.lpstrFindWhat    = szFindText ;
     fr.lpstrReplaceWith = NULL ;
     fr.wFindWhatLen     = MAX_STRING_LEN ;
     fr.wReplaceWithLen  = 0 ;
     fr.lCustData        = 0 ;
     fr.lpfnHook         = NULL ;
     fr.lpTemplateName   = NULL ;
     
     return FindText (&fr) ;
}

HWND PopFindReplaceDlg (HWND hwnd)
{
     static FINDREPLACE fr ;       // must be static for modeless dialog!!!
     
     fr.lStructSize      = sizeof (FINDREPLACE) ;
     fr.hwndOwner        = hwnd ;
     fr.hInstance        = NULL ;
     fr.Flags            = FR_HIDEMATCHCASE | FR_HIDEWHOLEWORD |  FR_DOWN;
     fr.lpstrFindWhat    = szFindText ;
     fr.lpstrReplaceWith = szReplText ;
     fr.wFindWhatLen     = MAX_STRING_LEN ;
     fr.wReplaceWithLen  = MAX_STRING_LEN ;
     fr.lCustData        = 0 ;
     fr.lpfnHook         = NULL ;
     fr.lpTemplateName   = NULL ;
     
     return ReplaceText (&fr) ;
}

BOOL PopFindFindText (HWND hwndEdit, int * piSearchOffset, LPFINDREPLACE pfr)
{
     int    iLength, iPos ;
     PTSTR  pstrDoc, pstrPos ;
     DWORD dwStartPos, dwFinishPos;
	 DWORD dwRes = SendMessage(hwndEdit, EM_GETSEL,
        (WPARAM)&dwStartPos, (LPARAM)&dwFinishPos);
          // Read in the edit document
//if (*piSearchOffset!=dwStartPos)
if (buttondown==true)
{
	buttondown=false;
*piSearchOffset=(int) dwStartPos;
}
     iLength = GetWindowTextLength (hwndEdit) ;
     
    if (NULL == (pstrDoc = (PTSTR) malloc ((iLength + 1) * sizeof (TCHAR))))
          return FALSE ;
     
     GetWindowText (hwndEdit, pstrDoc, iLength + 1) ;
     
          // Search the document for the find string
     //* piSearchOffset=0;
     pstrPos = _tcsstr (pstrDoc + * piSearchOffset, pfr->lpstrFindWhat) ;
     free (pstrDoc) ;
     
          // Return an error code if the string cannot be found
     
     if (pstrPos == NULL)
          return FALSE ;
     
          // Find the position in the document and the new start offset
     
     iPos = pstrPos - pstrDoc ;
     * piSearchOffset = iPos + lstrlen (pfr->lpstrFindWhat) ;
     
          // Select the found text
     
     SendMessage (hwndEdit, EM_SETSEL, iPos, * piSearchOffset) ;
	    // SendMessage (hwndEdit, EM_SETSEL, iPos, 0) ;
     SendMessage (hwndEdit, EM_SCROLLCARET, 0, 0) ;
     
     return TRUE ;
}

BOOL PopFindNextText (HWND hwndEdit, int * piSearchOffset)
{
     FINDREPLACE fr ;
     
     fr.lpstrFindWhat = szFindText ;
     
     return PopFindFindText (hwndEdit, piSearchOffset, &fr) ;
}

BOOL PopFindReplaceText (HWND hwndEdit, int * piSearchOffset, LPFINDREPLACE pfr)
{
          // Find the text
     
     if (!PopFindFindText (hwndEdit, piSearchOffset, pfr))
          return FALSE ;
     
          // Replace it
     
     SendMessage (hwndEdit, EM_REPLACESEL, 0, (LPARAM) pfr->lpstrReplaceWith) ;
     
     return TRUE ;
}

BOOL PopFindValidFind (void)
{
     return * szFindText != '\0' ;
}