#include <windows.h>
#include <tchar.h>
#include "resource.h"
#include <commdlg.h>
#include <tchar.h>            // for _tcsstr (strstr for Unicode & non-Unicode)
   static HWND               hDlgFind;
#define MAX_STRING_LEN   256
static HWND  hDlgModeless;
static TCHAR szFindText [MAX_STRING_LEN] ;
static TCHAR szReplText [MAX_STRING_LEN] ;
static CHAR  szReplWhat[80];
bool buttondown=false;
HWND PopFindFindDlg (HWND);
HWND PopFindReplaceDlg (HWND);
//BOOL PopFindFindText (HWND, int *, LPFINDREPLACE);
BOOL PopFindFindText (HWND hwndEdit, int * piSearchOffset, LPFINDREPLACE);
BOOL PopFindNextText (HWND, int *);
BOOL PopFindReplaceText (HWND, int *, LPFINDREPLACE);
BOOL PopFindValidFind (void);
//create text be searched
const TCHAR worddata[] ="It was the best of times, it was the worst of times,"\
" it was the age of wisdom, it was the age of foolishness, it was the epoch of belief"\
", it was the epoch of incredulity, it was the season of Light, "\
"it was the season of Darkness, it was the spring of hope, it was the winter of despair, "\
"we had everything before us, we had nothing before us, we were all going direct to Heaven, "\
"we were all going direct the other way  in short, the period was so far like the present period, "\
"that some of its noisiest authorities insisted on its being received, for good or for evil, "\
"in the superlative degree of comparison only.";
HINSTANCE hInst = NULL;
const UINT uFindReplaceMsg = RegisterWindowMessage(FINDMSGSTRING);//Registering FINDMSGSTRING
HWND hdlg = NULL;     // handle to Find dialog box
int findFrom = 0;
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;
//search file 
int SearchFile(const TCHAR* find, BOOL down, BOOL ignoreCase)
{
if(0 < _tcslen(find))
{
const TCHAR* start = &worddata[findFrom];
const TCHAR* pos   = _tcsstr(start, find);
if(NULL != pos)
{
int foundAt = (pos - worddata);
findFrom = foundAt + _tcslen(find);
return foundAt;
}
}
findFrom = 0;
return -1;
}
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
PSTR szCmdLine, int iCmdShow)
{
static TCHAR szAppName[] = TEXT ("TextFind Demo") ; 
HWND         hwnd ;
MSG          msg ;
WNDCLASS     wndclass = {0}; 
hInst = hInstance;
wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
wndclass.lpfnWndProc   = WndProc ;
wndclass.cbClsExtra    = 0 ;
wndclass.cbWndExtra    = 0 ;
wndclass.hInstance     = hInstance ;
wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
wndclass.hbrBackground = NULL; 
wndclass.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU1); 
wndclass.lpszClassName = szAppName ;
if (!RegisterClass (&wndclass))
{
MessageBox (NULL, TEXT ("Program requires Windows NT!"), 
szAppName, MB_ICONERROR) ;
return 0 ;
}
hwnd = CreateWindow (szAppName, TEXT ("Find Text in Edit Control Demo"),WS_OVERLAPPEDWINDOW,CW_USEDEFAULT, CW_USEDEFAULT,CW_USEDEFAULT, CW_USEDEFAULT,NULL, NULL, hInstance, NULL) ;
ShowWindow (hwnd, iCmdShow) ;
UpdateWindow (hwnd) ;
while (GetMessage (&msg, NULL, 0, 0))
{
TranslateMessage (&msg) ;
DispatchMessage (&msg) ;
}
return msg.wParam ;
}
LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)

{
	     static HWND      hwndEdit ;
     static int iOffset ;
     FINDREPLACE far* lpfr;
  /* LPFINDREPLACE lpfr; */
    FARPROC lpProcAbout;		  /* pointer to the "About" function */

    switch (message) {

		case WM_CREATE:
hwndEdit  = CreateWindow (TEXT("EDIT"), worddata,WS_CHILD | WS_VISIBLE | ES_MULTILINE|ES_READONLY  | ES_NOHIDESEL,0, 0, 0, 0,  hwnd, (HMENU)100, hInst, NULL) ;
break;
      case WM_SETFOCUS:
           SetFocus (hwndEdit);
           return 0;

	case WM_COMMAND:	   /* message: command from application menu */
          switch (LOWORD(wParam)) {
            case IDM_FIND:
                SendMessage (hwndEdit, EM_GETSEL, 0, (LPARAM) &iOffset) ;
   hDlgFind = FindDialog (hWnd) ;
                return 0;

            case IDM_SEARCHNEXT:
                SendMessage (hwndEdit, EM_GETSEL, 0, (LPARAM) &iOffset) ;

                if (PopFindValidFind())
                    PopFindNextText (hwndEdit, &iOffset) ;
                else
                    hDlgFind = FindDialog (hWnd) ;
                    return 0;

            case IDM_SEARCHPREV:
                /* locate previous search string in edit control */
                return 0;

            case IDM_ABOUT: {
		    lpProcAbout = MakeProcInstance(About, hInst);

		    DialogBox(hInst,		 /* current instance	     */
		        "AboutBox",		 /* resource to use	     */
		        hWnd,			 /* parent handle	     */
		        lpProcAbout);		 /* About() instance address */

		    FreeProcInstance(lpProcAbout);
                }
		    return 0;

           }
           break;

	case WM_DESTROY:		  /* message: window being destroyed */
	    PostQuitMessage(0);
	    return 0;

	default:			  /* Passes it on if unproccessed    */
            /* this can be a message from the modeless Find Text window */
            if (message == wFRMsg)
            {
                lpfr = (LPFINDREPLACE)lParam;

                if (lpfr->Flags & FR_DIALOGTERM)
                {
                    hDlgFind = NULL;   /* invalidate modeless window handle */
                    return 0;
                }
                else if (lpfr->Flags & FR_FINDNEXT)
                    if (!PopFindFindText (hwndEdit, &iOffset, lpfr))
                        MessageBox (hWnd, "String Not Found", "Editfile", MB_OK);
                return 0;
            }
            break;

    }
    return (DefWindowProc(hWnd, message, wParam, lParam));
}